/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.customsearch.model;

import com.google.api.client.json.GenericJson;
import com.google.api.client.json.JsonString;

/**
 * Model definition for Query.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the CustomSearch API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Query extends GenericJson {

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Integer count;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String cr;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String cref;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String cx;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String dateRestrict;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String disableCnTwTranslation;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String exactTerms;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String excludeTerms;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String fileType;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String filter;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String gl;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String googleHost;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String highRange;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String hl;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String hq;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String imgColorType;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String imgDominantColor;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String imgSize;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String imgType;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String inputEncoding;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String language;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String linkSite;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String lowRange;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String orTerms;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String outputEncoding;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String relatedSite;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String rights;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String safe;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String searchTerms;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String searchType;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String siteSearch;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String siteSearchFilter;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String sort;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Integer startIndex;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Integer startPage;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String title;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @JsonString
  private Long totalResults;

  /**

   * The value returned may be {@code null}.
   */
  public Integer getCount() {
    return count;
  }

  /**

   * The value set may be {@code null}.
   */
  public Query setCount(Integer count) {
    this.count = count;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getCr() {
    return cr;
  }

  /**

   * The value set may be {@code null}.
   */
  public Query setCr(String cr) {
    this.cr = cr;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getCref() {
    return cref;
  }

  /**

   * The value set may be {@code null}.
   */
  public Query setCref(String cref) {
    this.cref = cref;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getCx() {
    return cx;
  }

  /**

   * The value set may be {@code null}.
   */
  public Query setCx(String cx) {
    this.cx = cx;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getDateRestrict() {
    return dateRestrict;
  }

  /**

   * The value set may be {@code null}.
   */
  public Query setDateRestrict(String dateRestrict) {
    this.dateRestrict = dateRestrict;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getDisableCnTwTranslation() {
    return disableCnTwTranslation;
  }

  /**

   * The value set may be {@code null}.
   */
  public Query setDisableCnTwTranslation(String disableCnTwTranslation) {
    this.disableCnTwTranslation = disableCnTwTranslation;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getExactTerms() {
    return exactTerms;
  }

  /**

   * The value set may be {@code null}.
   */
  public Query setExactTerms(String exactTerms) {
    this.exactTerms = exactTerms;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getExcludeTerms() {
    return excludeTerms;
  }

  /**

   * The value set may be {@code null}.
   */
  public Query setExcludeTerms(String excludeTerms) {
    this.excludeTerms = excludeTerms;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getFileType() {
    return fileType;
  }

  /**

   * The value set may be {@code null}.
   */
  public Query setFileType(String fileType) {
    this.fileType = fileType;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getFilter() {
    return filter;
  }

  /**

   * The value set may be {@code null}.
   */
  public Query setFilter(String filter) {
    this.filter = filter;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getGl() {
    return gl;
  }

  /**

   * The value set may be {@code null}.
   */
  public Query setGl(String gl) {
    this.gl = gl;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getGoogleHost() {
    return googleHost;
  }

  /**

   * The value set may be {@code null}.
   */
  public Query setGoogleHost(String googleHost) {
    this.googleHost = googleHost;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getHighRange() {
    return highRange;
  }

  /**

   * The value set may be {@code null}.
   */
  public Query setHighRange(String highRange) {
    this.highRange = highRange;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getHl() {
    return hl;
  }

  /**

   * The value set may be {@code null}.
   */
  public Query setHl(String hl) {
    this.hl = hl;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getHq() {
    return hq;
  }

  /**

   * The value set may be {@code null}.
   */
  public Query setHq(String hq) {
    this.hq = hq;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getImgColorType() {
    return imgColorType;
  }

  /**

   * The value set may be {@code null}.
   */
  public Query setImgColorType(String imgColorType) {
    this.imgColorType = imgColorType;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getImgDominantColor() {
    return imgDominantColor;
  }

  /**

   * The value set may be {@code null}.
   */
  public Query setImgDominantColor(String imgDominantColor) {
    this.imgDominantColor = imgDominantColor;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getImgSize() {
    return imgSize;
  }

  /**

   * The value set may be {@code null}.
   */
  public Query setImgSize(String imgSize) {
    this.imgSize = imgSize;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getImgType() {
    return imgType;
  }

  /**

   * The value set may be {@code null}.
   */
  public Query setImgType(String imgType) {
    this.imgType = imgType;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getInputEncoding() {
    return inputEncoding;
  }

  /**

   * The value set may be {@code null}.
   */
  public Query setInputEncoding(String inputEncoding) {
    this.inputEncoding = inputEncoding;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getLanguage() {
    return language;
  }

  /**

   * The value set may be {@code null}.
   */
  public Query setLanguage(String language) {
    this.language = language;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getLinkSite() {
    return linkSite;
  }

  /**

   * The value set may be {@code null}.
   */
  public Query setLinkSite(String linkSite) {
    this.linkSite = linkSite;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getLowRange() {
    return lowRange;
  }

  /**

   * The value set may be {@code null}.
   */
  public Query setLowRange(String lowRange) {
    this.lowRange = lowRange;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getOrTerms() {
    return orTerms;
  }

  /**

   * The value set may be {@code null}.
   */
  public Query setOrTerms(String orTerms) {
    this.orTerms = orTerms;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getOutputEncoding() {
    return outputEncoding;
  }

  /**

   * The value set may be {@code null}.
   */
  public Query setOutputEncoding(String outputEncoding) {
    this.outputEncoding = outputEncoding;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getRelatedSite() {
    return relatedSite;
  }

  /**

   * The value set may be {@code null}.
   */
  public Query setRelatedSite(String relatedSite) {
    this.relatedSite = relatedSite;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getRights() {
    return rights;
  }

  /**

   * The value set may be {@code null}.
   */
  public Query setRights(String rights) {
    this.rights = rights;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getSafe() {
    return safe;
  }

  /**

   * The value set may be {@code null}.
   */
  public Query setSafe(String safe) {
    this.safe = safe;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getSearchTerms() {
    return searchTerms;
  }

  /**

   * The value set may be {@code null}.
   */
  public Query setSearchTerms(String searchTerms) {
    this.searchTerms = searchTerms;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getSearchType() {
    return searchType;
  }

  /**

   * The value set may be {@code null}.
   */
  public Query setSearchType(String searchType) {
    this.searchType = searchType;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getSiteSearch() {
    return siteSearch;
  }

  /**

   * The value set may be {@code null}.
   */
  public Query setSiteSearch(String siteSearch) {
    this.siteSearch = siteSearch;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getSiteSearchFilter() {
    return siteSearchFilter;
  }

  /**

   * The value set may be {@code null}.
   */
  public Query setSiteSearchFilter(String siteSearchFilter) {
    this.siteSearchFilter = siteSearchFilter;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getSort() {
    return sort;
  }

  /**

   * The value set may be {@code null}.
   */
  public Query setSort(String sort) {
    this.sort = sort;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public Integer getStartIndex() {
    return startIndex;
  }

  /**

   * The value set may be {@code null}.
   */
  public Query setStartIndex(Integer startIndex) {
    this.startIndex = startIndex;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public Integer getStartPage() {
    return startPage;
  }

  /**

   * The value set may be {@code null}.
   */
  public Query setStartPage(Integer startPage) {
    this.startPage = startPage;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getTitle() {
    return title;
  }

  /**

   * The value set may be {@code null}.
   */
  public Query setTitle(String title) {
    this.title = title;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public Long getTotalResults() {
    return totalResults;
  }

  /**

   * The value set may be {@code null}.
   */
  public Query setTotalResults(Long totalResults) {
    this.totalResults = totalResults;
    return this;
  }

}
