/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.customsearch.model;

import com.google.api.client.json.GenericJson;

/**
 * Model definition for Result.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the CustomSearch API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Result extends GenericJson {

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String cacheId;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String displayLink;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String fileFormat;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String formattedUrl;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String htmlFormattedUrl;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String htmlSnippet;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String htmlTitle;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Image image;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Labels> labels;

  static {
    // hack to force ProGuard to consider Labels used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(Labels.class);
  }

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String link;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String mime;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.Map<String, java.util.List<java.util.Map<String, Object>>> pagemap;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String snippet;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String title;

  /**

   * The value returned may be {@code null}.
   */
  public String getCacheId() {
    return cacheId;
  }

  /**

   * The value set may be {@code null}.
   */
  public Result setCacheId(String cacheId) {
    this.cacheId = cacheId;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getDisplayLink() {
    return displayLink;
  }

  /**

   * The value set may be {@code null}.
   */
  public Result setDisplayLink(String displayLink) {
    this.displayLink = displayLink;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getFileFormat() {
    return fileFormat;
  }

  /**

   * The value set may be {@code null}.
   */
  public Result setFileFormat(String fileFormat) {
    this.fileFormat = fileFormat;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getFormattedUrl() {
    return formattedUrl;
  }

  /**

   * The value set may be {@code null}.
   */
  public Result setFormattedUrl(String formattedUrl) {
    this.formattedUrl = formattedUrl;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getHtmlFormattedUrl() {
    return htmlFormattedUrl;
  }

  /**

   * The value set may be {@code null}.
   */
  public Result setHtmlFormattedUrl(String htmlFormattedUrl) {
    this.htmlFormattedUrl = htmlFormattedUrl;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getHtmlSnippet() {
    return htmlSnippet;
  }

  /**

   * The value set may be {@code null}.
   */
  public Result setHtmlSnippet(String htmlSnippet) {
    this.htmlSnippet = htmlSnippet;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getHtmlTitle() {
    return htmlTitle;
  }

  /**

   * The value set may be {@code null}.
   */
  public Result setHtmlTitle(String htmlTitle) {
    this.htmlTitle = htmlTitle;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public Image getImage() {
    return image;
  }

  /**

   * The value set may be {@code null}.
   */
  public Result setImage(Image image) {
    this.image = image;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**

   * The value set may be {@code null}.
   */
  public Result setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public java.util.List<Labels> getLabels() {
    return labels;
  }

  /**

   * The value set may be {@code null}.
   */
  public Result setLabels(java.util.List<Labels> labels) {
    this.labels = labels;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getLink() {
    return link;
  }

  /**

   * The value set may be {@code null}.
   */
  public Result setLink(String link) {
    this.link = link;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getMime() {
    return mime;
  }

  /**

   * The value set may be {@code null}.
   */
  public Result setMime(String mime) {
    this.mime = mime;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public java.util.Map<String, java.util.List<java.util.Map<String, Object>>> getPagemap() {
    return pagemap;
  }

  /**

   * The value set may be {@code null}.
   */
  public Result setPagemap(java.util.Map<String, java.util.List<java.util.Map<String, Object>>> pagemap) {
    this.pagemap = pagemap;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getSnippet() {
    return snippet;
  }

  /**

   * The value set may be {@code null}.
   */
  public Result setSnippet(String snippet) {
    this.snippet = snippet;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getTitle() {
    return title;
  }

  /**

   * The value set may be {@code null}.
   */
  public Result setTitle(String title) {
    this.title = title;
    return this;
  }

  /**
   * Model definition for ResultImage.
   */
  public static final class Image extends GenericJson {

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private Integer byteSize;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String contextLink;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private Integer height;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private Integer thumbnailHeight;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String thumbnailLink;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private Integer thumbnailWidth;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private Integer width;

    /**

     * The value returned may be {@code null}.
     */
    public Integer getByteSize() {
      return byteSize;
    }

    /**

     * The value set may be {@code null}.
     */
    public Image setByteSize(Integer byteSize) {
      this.byteSize = byteSize;
      return this;
    }

    /**

     * The value returned may be {@code null}.
     */
    public String getContextLink() {
      return contextLink;
    }

    /**

     * The value set may be {@code null}.
     */
    public Image setContextLink(String contextLink) {
      this.contextLink = contextLink;
      return this;
    }

    /**

     * The value returned may be {@code null}.
     */
    public Integer getHeight() {
      return height;
    }

    /**

     * The value set may be {@code null}.
     */
    public Image setHeight(Integer height) {
      this.height = height;
      return this;
    }

    /**

     * The value returned may be {@code null}.
     */
    public Integer getThumbnailHeight() {
      return thumbnailHeight;
    }

    /**

     * The value set may be {@code null}.
     */
    public Image setThumbnailHeight(Integer thumbnailHeight) {
      this.thumbnailHeight = thumbnailHeight;
      return this;
    }

    /**

     * The value returned may be {@code null}.
     */
    public String getThumbnailLink() {
      return thumbnailLink;
    }

    /**

     * The value set may be {@code null}.
     */
    public Image setThumbnailLink(String thumbnailLink) {
      this.thumbnailLink = thumbnailLink;
      return this;
    }

    /**

     * The value returned may be {@code null}.
     */
    public Integer getThumbnailWidth() {
      return thumbnailWidth;
    }

    /**

     * The value set may be {@code null}.
     */
    public Image setThumbnailWidth(Integer thumbnailWidth) {
      this.thumbnailWidth = thumbnailWidth;
      return this;
    }

    /**

     * The value returned may be {@code null}.
     */
    public Integer getWidth() {
      return width;
    }

    /**

     * The value set may be {@code null}.
     */
    public Image setWidth(Integer width) {
      this.width = width;
      return this;
    }

  }

  /**
   * Model definition for ResultLabels.
   */
  public static final class Labels extends GenericJson {

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String displayName;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String name;

    /**

     * The value returned may be {@code null}.
     */
    public String getDisplayName() {
      return displayName;
    }

    /**

     * The value set may be {@code null}.
     */
    public Labels setDisplayName(String displayName) {
      this.displayName = displayName;
      return this;
    }

    /**

     * The value returned may be {@code null}.
     */
    public String getName() {
      return name;
    }

    /**

     * The value set may be {@code null}.
     */
    public Labels setName(String name) {
      this.name = name;
      return this;
    }

  }

}
