/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.customsearch.model;

import com.google.api.client.json.GenericJson;
import com.google.api.client.json.JsonString;

/**
 * Model definition for Search.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the CustomSearch API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Search extends GenericJson {

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Context context;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Result> items;

  static {
    // hack to force ProGuard to consider Result used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(Result.class);
  }

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Promotion> promotions;

  static {
    // hack to force ProGuard to consider Promotion used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(Promotion.class);
  }

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.Map<String, java.util.List<Query>> queries;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private SearchInformation searchInformation;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Spelling spelling;

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Url url;

  /**

   * The value returned may be {@code null}.
   */
  public Context getContext() {
    return context;
  }

  /**

   * The value set may be {@code null}.
   */
  public Search setContext(Context context) {
    this.context = context;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public java.util.List<Result> getItems() {
    return items;
  }

  /**

   * The value set may be {@code null}.
   */
  public Search setItems(java.util.List<Result> items) {
    this.items = items;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**

   * The value set may be {@code null}.
   */
  public Search setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public java.util.List<Promotion> getPromotions() {
    return promotions;
  }

  /**

   * The value set may be {@code null}.
   */
  public Search setPromotions(java.util.List<Promotion> promotions) {
    this.promotions = promotions;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public java.util.Map<String, java.util.List<Query>> getQueries() {
    return queries;
  }

  /**

   * The value set may be {@code null}.
   */
  public Search setQueries(java.util.Map<String, java.util.List<Query>> queries) {
    this.queries = queries;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public SearchInformation getSearchInformation() {
    return searchInformation;
  }

  /**

   * The value set may be {@code null}.
   */
  public Search setSearchInformation(SearchInformation searchInformation) {
    this.searchInformation = searchInformation;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public Spelling getSpelling() {
    return spelling;
  }

  /**

   * The value set may be {@code null}.
   */
  public Search setSpelling(Spelling spelling) {
    this.spelling = spelling;
    return this;
  }

  /**

   * The value returned may be {@code null}.
   */
  public Url getUrl() {
    return url;
  }

  /**

   * The value set may be {@code null}.
   */
  public Search setUrl(Url url) {
    this.url = url;
    return this;
  }

  /**
   * Model definition for SearchSearchInformation.
   */
  public static final class SearchInformation extends GenericJson {

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String formattedSearchTime;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String formattedTotalResults;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private Double searchTime;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key @JsonString
    private Long totalResults;

    /**

     * The value returned may be {@code null}.
     */
    public String getFormattedSearchTime() {
      return formattedSearchTime;
    }

    /**

     * The value set may be {@code null}.
     */
    public SearchInformation setFormattedSearchTime(String formattedSearchTime) {
      this.formattedSearchTime = formattedSearchTime;
      return this;
    }

    /**

     * The value returned may be {@code null}.
     */
    public String getFormattedTotalResults() {
      return formattedTotalResults;
    }

    /**

     * The value set may be {@code null}.
     */
    public SearchInformation setFormattedTotalResults(String formattedTotalResults) {
      this.formattedTotalResults = formattedTotalResults;
      return this;
    }

    /**

     * The value returned may be {@code null}.
     */
    public Double getSearchTime() {
      return searchTime;
    }

    /**

     * The value set may be {@code null}.
     */
    public SearchInformation setSearchTime(Double searchTime) {
      this.searchTime = searchTime;
      return this;
    }

    /**

     * The value returned may be {@code null}.
     */
    public Long getTotalResults() {
      return totalResults;
    }

    /**

     * The value set may be {@code null}.
     */
    public SearchInformation setTotalResults(Long totalResults) {
      this.totalResults = totalResults;
      return this;
    }

  }

  /**
   * Model definition for SearchSpelling.
   */
  public static final class Spelling extends GenericJson {

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String correctedQuery;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String htmlCorrectedQuery;

    /**

     * The value returned may be {@code null}.
     */
    public String getCorrectedQuery() {
      return correctedQuery;
    }

    /**

     * The value set may be {@code null}.
     */
    public Spelling setCorrectedQuery(String correctedQuery) {
      this.correctedQuery = correctedQuery;
      return this;
    }

    /**

     * The value returned may be {@code null}.
     */
    public String getHtmlCorrectedQuery() {
      return htmlCorrectedQuery;
    }

    /**

     * The value set may be {@code null}.
     */
    public Spelling setHtmlCorrectedQuery(String htmlCorrectedQuery) {
      this.htmlCorrectedQuery = htmlCorrectedQuery;
      return this;
    }

  }

  /**
   * Model definition for SearchUrl.
   */
  public static final class Url extends GenericJson {

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String template;

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String type;

    /**

     * The value returned may be {@code null}.
     */
    public String getTemplate() {
      return template;
    }

    /**

     * The value set may be {@code null}.
     */
    public Url setTemplate(String template) {
      this.template = template;
      return this;
    }

    /**

     * The value returned may be {@code null}.
     */
    public String getType() {
      return type;
    }

    /**

     * The value set may be {@code null}.
     */
    public Url setType(String type) {
      this.type = type;
      return this;
    }

  }
}
